#   This program demonstrates using an open office spreadsheet as a
#   repository for problems needing solution by GLPK

#  Nigel_Galloway@operamail.com
#  July 29th., 2008.
#

require 'KuKu_vfs'

class Sudoku_vfs < KuKu_vfs
  def initialize(args)
    super(args);
    @rows = 9;
    @cols = 9;
    @Zymbolz=9;
  end

  def handleCell(rN,cN,v)
    if v[0]=='x' or rN>9 or cN>9 then return end
    addCells(@sNo,rN,cN,rN,cN);
    addZum(@zNo,@sNo,@sNo,v[0]);
    @sNo+=1;
    @zNo+=1;
  end

  def setFixed
    super
    addCells(1,1,1,1,9)
    addCells(2,2,1,2,9)
    addCells(3,3,1,3,9)
    addCells(4,4,1,4,9)
    addCells(5,5,1,5,9)
    addCells(6,6,1,6,9)
    addCells(7,7,1,7,9)
    addCells(8,8,1,8,9)
    addCells(9,9,1,9,9)
    addCells(10,1,1,9,1)
    addCells(11,1,2,9,2)
    addCells(12,1,3,9,3)
    addCells(13,1,4,9,4)
    addCells(14,1,5,9,5)
    addCells(15,1,6,9,6)
    addCells(16,1,7,9,7)
    addCells(17,1,8,9,8)
    addCells(18,1,9,9,9)
    addCells(19,1,1,3,3)
    addCells(20,1,4,3,6)
    addCells(21,1,7,3,9)
    addCells(22,4,1,6,3)
    addCells(23,4,4,6,6)
    addCells(24,4,7,6,9)
    addCells(25,7,1,9,3)
    addCells(26,7,4,9,6)
    addCells(27,7,7,9,9)
    addCells(28,1,1,9,9)
    addBlock(1,1,1);
    addBlock(2,2,2);
    addBlock(3,3,3);
    addBlock(4,4,4);
    addBlock(5,5,5);
    addBlock(6,6,6);
    addBlock(7,7,7);
    addBlock(8,8,8);
    addBlock(9,9,9);
    addBlock(10,10,10);
    addBlock(11,11,11);
    addBlock(12,12,12);
    addBlock(13,13,13);
    addBlock(14,14,14);
    addBlock(15,15,15);
    addBlock(16,16,16);
    addBlock(17,17,17);
    addBlock(18,18,18);
    addBlock(19,19,19);
    addBlock(20,20,20);
    addBlock(21,21,21);
    addBlock(22,22,22);
    addBlock(23,23,23);
    addBlock(24,24,24);
    addBlock(25,25,25);
    addBlock(26,26,26);
    addBlock(27,27,27);
    addCblock(1,28,28);
    @sNo=29;
    @zNo=1;
  end
end

Sudoku_vfs.new(ARGV).mount

